package com.ruoyi.platform.mapper;

import com.ruoyi.platform.domain.ModelsVersion;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * (ModelsVersion)表数据库访问层
 *
 * @author Xidaray
 * @since 2024-01-05 09:02:42
 */
public interface ModelsVersionDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    ModelsVersion queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param modelsVersion 查询条件
     * @param pageable         分页对象
     * @return 对象列表
     */
    List<ModelsVersion> queryAllByLimit(@Param("modelsVersion") ModelsVersion modelsVersion, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param modelsVersion 查询条件
     * @return 总行数
     */
    long count(@Param("modelsVersion") ModelsVersion modelsVersion);

    /**
     * 新增数据
     *
     * @param modelsVersion 实例对象
     * @return 影响行数
     */
    int insert(@Param("modelsVersion") ModelsVersion modelsVersion);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<ModelsVersion> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<ModelsVersion> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<ModelsVersion> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<ModelsVersion> entities);

    /**
     * 修改数据
     *
     * @param modelsVersion 实例对象
     * @return 影响行数
     */
    int update(@Param("modelsVersion") ModelsVersion modelsVersion);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    List<ModelsVersion> queryByModelsId(Integer modelsId);

    ModelsVersion queryByModelsVersion(@Param("modelsVersion") ModelsVersion modelsVersion);

    List<ModelsVersion> queryAllByModelsVersion(@Param("modelsId") Integer modelsId, @Param("version") String version);
}

